/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModelProperty;

import java.io.IOException;
import java.util.Objects;

/**
 * QuoteCustomizationCriteria
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class QuoteCustomizationCriteria {
  @SerializedName("includes_a_stop_over")
  private Boolean includesAStopOver = null;

  @SerializedName("is_fare_flexible")
  private Boolean isFareFlexible = null;

  /**
   * Category of the ticket
   */
  @JsonAdapter(CategoryEnum.Adapter.class)
  public enum CategoryEnum {
    ECONOMIC("Economic"),
    
    PREMIUM("Premium"),
    
    BUSINESS("Business");

    private String value;

    CategoryEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static CategoryEnum fromValue(String text) {
      for (CategoryEnum b : CategoryEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<CategoryEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final CategoryEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public CategoryEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return CategoryEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("category")
  private CategoryEnum category = null;

  @SerializedName("number_of_checked_in_luggage")
  private Integer numberOfCheckedInLuggage = null;

  @SerializedName("loyalty")
  private QuoteLoyalty loyalty = null;

  @SerializedName("product_customization")
  private String productCustomization = null;

  public QuoteCustomizationCriteria includesAStopOver(Boolean includesAStopOver) {
    this.includesAStopOver = includesAStopOver;
    return this;
  }

   /**
   * Does the travel include a stopover?
   * @return includesAStopOver
  **/
  @ApiModelProperty(required = true, value = "Does the travel include a stopover?")
  public Boolean isIncludesAStopOver() {
    return includesAStopOver;
  }

  public void setIncludesAStopOver(Boolean includesAStopOver) {
    this.includesAStopOver = includesAStopOver;
  }

  public QuoteCustomizationCriteria isFareFlexible(Boolean isFareFlexible) {
    this.isFareFlexible = isFareFlexible;
    return this;
  }

   /**
   * Is the ticket flexible?
   * @return isFareFlexible
  **/
  @ApiModelProperty(required = true, value = "Is the ticket flexible?")
  public Boolean isIsFareFlexible() {
    return isFareFlexible;
  }

  public void setIsFareFlexible(Boolean isFareFlexible) {
    this.isFareFlexible = isFareFlexible;
  }

  public QuoteCustomizationCriteria category(CategoryEnum category) {
    this.category = category;
    return this;
  }

   /**
   * Category of the ticket
   * @return category
  **/
  @ApiModelProperty(required = true, value = "Category of the ticket")
  public CategoryEnum getCategory() {
    return category;
  }

  public void setCategory(CategoryEnum category) {
    this.category = category;
  }

  public QuoteCustomizationCriteria numberOfCheckedInLuggage(Integer numberOfCheckedInLuggage) {
    this.numberOfCheckedInLuggage = numberOfCheckedInLuggage;
    return this;
  }

   /**
   * Luggage allowance (numbers of included luggages in the ticket)
   * minimum: 0
   * @return numberOfCheckedInLuggage
  **/
  @ApiModelProperty(required = true, value = "Luggage allowance (numbers of included luggages in the ticket)")
  public Integer getNumberOfCheckedInLuggage() {
    return numberOfCheckedInLuggage;
  }

  public void setNumberOfCheckedInLuggage(Integer numberOfCheckedInLuggage) {
    this.numberOfCheckedInLuggage = numberOfCheckedInLuggage;
  }

  public QuoteCustomizationCriteria loyalty(QuoteLoyalty loyalty) {
    this.loyalty = loyalty;
    return this;
  }

   /**
   * Get loyalty
   * @return loyalty
  **/
  @ApiModelProperty(value = "")
  public QuoteLoyalty getLoyalty() {
    return loyalty;
  }

  public void setLoyalty(QuoteLoyalty loyalty) {
    this.loyalty = loyalty;
  }

  public QuoteCustomizationCriteria productCustomization(String productCustomization) {
    this.productCustomization = productCustomization;
    return this;
  }

   /**
   * Criteria used to filter / select the applicable products from the catalog
   * @return productCustomization
  **/
  @ApiModelProperty(value = "Criteria used to filter / select the applicable products from the catalog")
  public String getProductCustomization() {
    return productCustomization;
  }

  public void setProductCustomization(String productCustomization) {
    this.productCustomization = productCustomization;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QuoteCustomizationCriteria quoteCustomizationCriteria = (QuoteCustomizationCriteria) o;
    return Objects.equals(this.includesAStopOver, quoteCustomizationCriteria.includesAStopOver) &&
        Objects.equals(this.isFareFlexible, quoteCustomizationCriteria.isFareFlexible) &&
        Objects.equals(this.category, quoteCustomizationCriteria.category) &&
        Objects.equals(this.numberOfCheckedInLuggage, quoteCustomizationCriteria.numberOfCheckedInLuggage) &&
        Objects.equals(this.loyalty, quoteCustomizationCriteria.loyalty) &&
        Objects.equals(this.productCustomization, quoteCustomizationCriteria.productCustomization);
  }

  @Override
  public int hashCode() {
    return Objects.hash(includesAStopOver, isFareFlexible, category, numberOfCheckedInLuggage, loyalty, productCustomization);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QuoteCustomizationCriteria {\n");
    
    sb.append("    includesAStopOver: ").append(toIndentedString(includesAStopOver)).append("\n");
    sb.append("    isFareFlexible: ").append(toIndentedString(isFareFlexible)).append("\n");
    sb.append("    category: ").append(toIndentedString(category)).append("\n");
    sb.append("    numberOfCheckedInLuggage: ").append(toIndentedString(numberOfCheckedInLuggage)).append("\n");
    sb.append("    loyalty: ").append(toIndentedString(loyalty)).append("\n");
    sb.append("    productCustomization: ").append(toIndentedString(productCustomization)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

